#include "RoboClawStream.h"
#define ADDRESS 0x80

RoboClawStream RClaw(&Serial3);

void setup() {
  Serial.begin(38400);
  delay (5000);
  Serial.println("Kurt's Rover Program Startup\n");

  Serial3.begin(38400);  // Not part of RClaw when simple stream sub-class
//  RClaw.begin(38400);

}

void loop() {
  // Start off seeing if I can talk to the RClaw at all... 
  char sz[100];
  bool fValid;
  uint8_t fStatus;
  uint16_t uMinV;
  uint16_t uMaxV;
  
  Serial.println("Enter ReadVersion");
  fValid = RClaw.ReadVersion(ADDRESS, sz);
  Serial.print("Read Version: (");
  Serial.print(fValid, DEC);
  Serial.print(") ");
  Serial.println(sz);
  
  Serial.println("Enter Battery Voltage");
  uint16_t uVolt = RClaw.ReadMainBatteryVoltage(ADDRESS, &fValid);
  Serial.print("Main Volt: ");
  Serial.print(fValid, DEC);
  Serial.print(" ");
  Serial.println(uVolt, DEC);
  
#if 1
  Serial.println("Enter Min/Max");
  fValid = RClaw.ReadMinMaxLogicVoltages(ADDRESS, uMinV, uMaxV);
  Serial.print("Min/Max: ");
  Serial.print(fValid, DEC);
  Serial.print(" ");
  Serial.print(uMinV, DEC);
  Serial.print(" ");
  Serial.println(uMaxV, DEC);
#endif
    
  Serial.println("Enter Read Enc");
  uint32_t ulV = RClaw.ReadEncM1(ADDRESS, &fStatus, &fValid);
  Serial.print("Enc 1: ");
  Serial.print(fStatus, DEC);
  Serial.print(" ");
  Serial.print(fValid, DEC);
  Serial.print(" ");
  Serial.println(ulV, DEC);

  ulV = RClaw.ReadEncM1(ADDRESS, &fStatus, &fValid);
  Serial.print("Enc 2: ");
  Serial.print(fStatus, DEC);
  Serial.print(" ");
  Serial.print(fValid, DEC);
  Serial.print(" ");
  Serial.println(ulV, DEC);
      
  delay(500);
}


